<?php
/*******************************************************************
 *			
 * 			Fichier			:	cron.php 
 * 			Cr le			:	25 mars 2003 
 * 			Dernire modif	:	14 juin 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_NEWSLETTER', true); 

$waroot = '../'; 
require($waroot . 'start.php'); 

load_settings(); 

$limit_security = 100; 
$liste_id		= ( !empty($_GET['liste']) ) ? intval($_GET['liste']) : 0; 

$sql = 'SELECT * FROM ' . LISTE_TABLE . ' 
	WHERE liste_id = ' . $liste_id; 
if( !($result = $db->query($sql)) )
{
	trigger_error('Impossible de rcuprer les informations sur cette liste', CRITICAL_ERROR); 
}

if( $listdata = $db->fetch_array($result) )
{
	include($waroot . 'includes/class.form.php'); 
	include($waroot . 'includes/class.mailer.php'); 
	include($waroot . 'includes/class.pop.php'); 
	include($waroot . 'includes/functions.validate.php'); 
	include($waroot . 'includes/functions.stats.php'); 
	
	//
	// On rgle le script pour ignorer une dconnexion du client
	//
	@ignore_user_abort(true); 
	
	//
	// On augmente galement le temps d'excution maximal du script. 
	//
	// Certains hbergeurs dsactivent pour des raisons videntes cette fonction
	// Si c'est votre cas, vous tes mal barr
	//
	@set_time_limit(120); 
	
	$mailer = new Mailer($waroot . 'language/email_' . $nl_config['language'] . '/'); 
	
	if( $nl_config['use_smtp'] )
	{
		$mailer->smtp_path = $waroot . 'includes/'; 
		$mailer->use_smtp(
			$nl_config['smtp_host'],
			$nl_config['smtp_port'],
			$nl_config['smtp_user'],
			$nl_config['smtp_pass']
		); 
	}
	
	$mailer->hebergeur = $nl_config['hebergeur']; 
	$mailer->charset   = $lang['CHARSET']; 
	$mailer->format	   = FORMAT_TEXTE; 
	
	$mailer->set_from($listdata['sender_email'], unhtmlspecialchars($listdata['liste_name'])); 
	
	$wanewsletter = new Wanewsletter($listdata); 
	
	list($account, $domaine) = array_map('preg_quote', explode('@', $listdata['sender_email'])); 
	
	$pop = new Pop(); 
	$pop->connect($listdata['pop_host'], $listdata['pop_port'], $listdata['pop_user'], $listdata['pop_pass']); 
	
	$total    = $pop->stat_box(); 
	$mail_box = $pop->list_mail(); 
	
	$cpt = 0; 
	
	foreach( $mail_box AS $mail_id => $mail_size )
	{
		$contents = $pop->read_mail($mail_id, 2); 
		$contents = preg_replace("/\r\n?/", "\n", $contents); 
		
		if( !preg_match('/^From:[ ]*(?:"([^" ]*)")?[ ]*(?:<)?([^> ]+)(?:>)?[ ]*$/im', $contents, $match) )
		{
			continue;
		}
		
		$pseudo = ( isset($match[1]) ) ? trim($match[1]) : ''; 
		$email  = trim($match[2]); 
		
		//
		// On vrifie si l'ventuel nom est encod en base64 ou en quoted-printable
		//
		if( preg_match('/^=\?[^?]+\?(Q|B)\?([^?]+)\?=$/', $pseudo, $match) )
		{
			if( $match[1] == 'Q' )
			{
				$pseudo = preg_replace('/=([a-fA-F0-9]{2})/e', 'chr(ord("\\x\\1"));', $match[2]); 
			}
			else
			{
				$pseudo = base64_decode($match[2]); 
			}
		}
		
		if( !preg_match('/^To:[ ]*(?:<)?' . $wanewsletter->liste_email . '(?:>)?[ ]*$/im', $contents, $match) )
		{
			continue;
		}
		
		if( !preg_match('/^Subject:[ ]*(.+?)$/im', $contents, $match) )
		{
			continue;
		}
		
		$action = strtolower(trim($match[1])); 
		
		switch( $action )
		{
			case 'desinscription':
			case 'unsubscribe':
				$action = 'desinscription'; 
				break;
			
			case 'inscription':
			case 'subscribe':
				$action = 'inscription'; 
				break;
			
			case 'confirmation':
			case 'setformat':
				break;
			
			default:
				continue 2;
				break;
		}
		
		if( preg_match("/[\n]{2,}(.*?)$/", $contents, $match) )
		{
			$code = trim($match[1]); 
		}
		
		if( $wanewsletter->account_info($email, addslashes(strip_tags($pseudo)), $code, $listdata['liste_format'], $action) )
		{
			switch( $action )
			{
				case 'desinscription':
				case 'unsubscribe':
					$wanewsletter->unsubscribe(); 
					break;
				
				case 'confirmation':
					$wanewsletter->confirm(); 
					break;
				
				case 'inscription':
				case 'subscribe':
					$wanewsletter->subscribe(); 
					break;
				
				case 'setformat':
					$sql = "SELECT format FROM " . ABO_LISTE_TABLE . " 
						WHERE abo_id = " . $wanewsletter->account['abo_id'] . " 
						  AND liste_id = " . $liste_id; 
					if( $result = $db->query($sql) )
					{
						$format = $db->result($result, 0, 'format'); 
						
						switch( $format )
						{
							case FORMAT_TEXTE:
								$wanewsletter->format = FORMAT_HTML; 
								break;
							
							case FORMAT_HTML:
							default:
								$wanewsletter->format = FORMAT_TEXTE; 
								break;
						}
					}
					
					$wanewsletter->setformat(); 
					break;
				
				default:
					$pop->delete_mail($mail_id); 
					continue 2;
					break;
			}
		}
		
		//
		// On supprime l'email maintenant devenu inutile
		//
		$pop->delete_mail($mail_id); 
		
		if( $wanewsletter->update_stats )
		{
			update_stats($listdata); 
		}
		
		$cpt++; 
		
		if( $cpt > $limit_security )
		{
			break;
		}
	}//end for
	
	$pop->quit(); 
	
	exit('<br /><br />Opration effectue avec succs'); 
}
else
{
	exit('Identifiant de liste invalide'); 
}

?>